import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.Image;
import java.util.*;
import java.net.*;


/** An instance is a GUI for assignment A7 of CS1110, Fall 2008 */
public class A7GUI extends JFrame {
    
    private A7 thisA7;  // The instance of A7 that created this instance of A7GUI
    
    private JComboBox topicsJList; // The list of topics
    
    /** The list of numbers and associate terms to guess. if not empty, one is always selected */
    private JComboBox jNumbers= new JComboBox();
    private JComboBox jTerms= new JComboBox();
    
    private JPanel jpanel= new JPanel(); // The panel that contains the image

    private JButton OKButton= new JButton("OK"); // Button to click when user has chosen a term
    private JButton topicButton= new JButton("topic"); // Button to click when user has chosen a topic
   
    ButtonListener buttonListener= new ButtonListener(); // Instance for listening to buttons
    
    /** Constructor: An instance with list t of topics and empty lists of numbers
                     and terms, called from thisA7.  */
    public A7GUI(Vector<String> t, A7 thisA7) {
        this.thisA7= thisA7;
        setTitle("Play the terminology game: Quizit");
        setUp(t);
        pack();
        setVisible(true);
    }
    
    /** = the A7 that set up this JFrame */
    public A7 getA7() {
        return thisA7;
    }
    
    /** Set up the GUI with list of topics tList and empty number-term lists.
        Precondition: the three lists are not null (they may be empty) */
    private void setUp(Vector<String> tList) {
        // Fix it so that clicking the close button terminates the program
        //setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        
        Container cp= getContentPane();
        
        // Create the jpanel and add it to this JFrame
        jpanel= new A7Panel(null, thisA7);
        cp.add(jpanel, BorderLayout.CENTER);
        
        // Fix the north box
        Box northBox= new Box(BoxLayout.Y_AXIS);
        
        Box c0label= new Box(BoxLayout.X_AXIS);
        JLabel game1= new JLabel("  Play a game to learn some terminology about some topic.", SwingConstants.LEFT);
        JLabel game2= new JLabel("  First, choose a topic from the drop-down menu on the left and click button 'topic'. A picture will appear.  ");
        JLabel game3= new JLabel("  Second, use the other two drop-down menus to select a label (number) and the term for that part  ");
        JLabel game4= new JLabel("  and click button 'OK'. ");
        JLabel game5= new JLabel("  If you are right, the term will appear in green; otherwise, the term will be red, and you can try again.");
        JLabel game6= new JLabel("  Continue guessing labels and terms as long as you want, or choose another topic.");
        
        Box labelBox= new Box(BoxLayout.Y_AXIS);
        labelBox.add(game1);
        labelBox.add(Box.createVerticalStrut(10));
        labelBox.add(game2);
        labelBox.add(Box.createVerticalStrut(4));
        labelBox.add(game3);
        labelBox.add(game4);
        labelBox.add(Box.createVerticalStrut(4));
        labelBox.add(game5);
        labelBox.add(Box.createVerticalStrut(4));
        labelBox.add(game6);
        
        c0label.add(labelBox);
        c0label.add(Box.createHorizontalGlue());
        
        northBox.add(c0label);
        northBox.add(Box.createVerticalStrut(10));
        
        Box cBox= new Box(BoxLayout.X_AXIS);
        
        Box c1Box= new Box(BoxLayout.Y_AXIS);
        
        Box c1label= new Box(BoxLayout.X_AXIS);
        c1label.add(new JLabel("  Choose a topic and click \"topic\""));
        c1label.add(Box.createHorizontalGlue());
        c1Box.add(c1label);
                  
        Box c1buttons= new Box(BoxLayout.X_AXIS);
        topicsJList= new JComboBox(tList);
        c1buttons.add(topicsJList);
        
        c1buttons.add(topicButton);
        topicButton.addActionListener(buttonListener);
        
        c1Box.add(c1buttons);    
        cBox.add(c1Box);
        cBox.add(Box.createHorizontalStrut(15));
        
        Box c2Box= new Box(BoxLayout.Y_AXIS);
        
        Box c2label= new Box(BoxLayout.X_AXIS);
        c2label.add(new JLabel("  Choose a number and term and click \"OK\""));
        c2label.add(Box.createHorizontalGlue());
        c2Box.add(c2label);
        
        Box c2buttons= new Box(BoxLayout.X_AXIS);
        
        jNumbers.removeAllItems();
        jNumbers.setEditable(false);
        c2buttons.add(jNumbers);
        
        jTerms.removeAllItems();
        jTerms.setEditable(false);
        c2buttons.add(jTerms);
        
        c2buttons.add(OKButton);
        OKButton.addActionListener(buttonListener);
        c2buttons.add(Box.createHorizontalGlue());
        
        c2Box.add(c2buttons);
        
        cBox.add(c2Box);
        cBox.add(Box.createHorizontalGlue());
        
        northBox.add(cBox);
        
        northBox.add(Box.createVerticalStrut(10));
        
        cp.add(northBox, BorderLayout.NORTH);
        
    }
    
    /** Set up topic with image given by file name f */
    public void setUpImage(String f) {
        Image im= getImage(f);
            
        Container cp= getContentPane();
        cp.remove(jpanel);
        jpanel= new A7Panel(im, thisA7);
        cp.add(jpanel, BorderLayout.CENTER);
        pack();
    }
    
    /** = the image for file name f, using this jframe's toolkit or the applet */
    private Image getImage(String f) {
        Image image= null;
        try {
            if (thisA7.isApplet()) {
                URL url= thisA7.getClass().getResource( f );
                image= thisA7.getToolkit().getImage(url);
            } else {
                 image= getToolkit().getImage(new URL("file:" + f));
            }
            System.out.println("image " + f);
        } 
        catch (MalformedURLException e) {
            System.err.println("Bad URL!");
            return null;
        }
        
        // set media tracker to wait for image to load
        MediaTracker tracker= new MediaTracker(this);
        tracker.addImage(image,0);    
        
        // wait for image to load
        try { 
            tracker.waitForID(0); 
        }
        catch (InterruptedException e) {
            // handler.flashMessage(ImageHandler.LOAD_INTERRUPTED);
            return null;
        }
        return image;
    }
    
    /** Initialize the drop-down lists of numbers and terms to empty */
    public void emptyComboBoxes() {
        jNumbers.removeAllItems();
        jTerms.removeAllItems();
    }
    
    /** Add n to the drop-down list of numbers for the user to choose from */
    public void addToComboBox(Integer n) {
        jNumbers.addItem(n);
        jNumbers.setMaximumRowCount(jNumbers.getItemCount());
    }
    
    /** Add s to the drop-down list of terms for the user to choose from */
    public void addToComboBox(String s) {
        jTerms.addItem(s);
        jTerms.setMaximumRowCount(jTerms.getItemCount());
    }

    /** Delete n from the drop-down list of numbers for the user to choose from.*/
    public void removeFromNumberList(int n) {
        int size= jNumbers.getItemCount();
        // inv: items 0..k-1 are not equal to n
        for (int k= 0; k != size; k= k+1) {
            if (((Integer)(jNumbers.getItemAt(k))).equals(n)) {
                jNumbers.removeItemAt(k);
                if (jNumbers.getItemCount() != 0) {
                    jNumbers.setSelectedIndex(0);
                }
                return;
            }
        }
    }
    
    /** Delete s from the drop-down list of terms for the user to choose from */
    public void removeFromTermList(String s) {
        int size= jTerms.getItemCount();
        // inv: items 0..k-1 are not equal to n
        for (int k= 0; k != size; k= k+1) {
            if (((String)(jTerms.getItemAt(k))).equals(s)) {
                jTerms.removeItemAt(k);
                if (jTerms.getItemCount() != 0) {
                    jTerms.setSelectedIndex(0);
                }
                return;
            }
        }
    }
    
    /** An instance responds to mouse clicks on the two buttons */
    public class ButtonListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            Object ob= e.getSource();
            if (!(ob instanceof JButton)) {
                return;
            }
            
            JButton jb= (JButton) ob;
            if (jb == OKButton) {
                if (jNumbers.getSelectedIndex() == -1 ||
                    jTerms.getSelectedIndex() == -1) {
                    System.out.println("Cannot process OK click because a number or a term is not selected");
                    return;
                }
                
                Object on= jNumbers.getSelectedItem();
                int n= (Integer) on;
                
                Object oterm= jTerms.getSelectedItem();
                String term= (String) oterm;
                
                thisA7.associateTerm(term, n);
                repaint();
                return;
            }
            
            if (jb == topicButton) {
                Object n= topicsJList.getSelectedItem();
                if (n == null)
                    return;
                
                thisA7.startTopic((String) n);
                return;
            }
        }
    }

}