import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.Image;

/** An instance is a Panel that contains the image, labels, etc. for the A7 game */
public class A7Panel extends JPanel {
    private A7 drawer; // The instance of A7 that will draw lines and labels
    
    private int width= 28;  // width of panel
    private int height= 23; // height of panel
    private Image im; // the image in this panel
   
    /** Constructor: A JPanel with image im */
    public A7Panel(Image im, A7 drawer) {
        this.im= im;
        this.drawer= drawer;
        if (im == null)
            return;
        int width= im.getWidth(this);
        int height= im.getHeight(this);
        Dimension dim= new Dimension(width, height);
        setSize(dim);
        setPreferredSize(dim);
        System.out.println("Have image " + im);
    }
    
    /** Paint the square, using Graphics g.
        Information: Calls A7.drawLinesLabels in order to draw the lines and numbers and terms.*/
       public void paint (Graphics g) {
           Color save= g.getColor(); // Save the color, to be reset at end
          
           g.drawImage(im, 0, 0, this);
           drawer.drawLinesLabels(g);
           
           g.setColor(save);
       }
}